Attribute VB_Name = "mdlFakeBarCode"
Option Explicit

'Download by http://www.NewXing.com
Private Type PictDesc

    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long

End Type

Private Type Guid

    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(0 To 7) As Byte

End Type

Private Type BITMAPINFOHEADER

    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long

End Type

Private Type BITMAPINFO

    bmiHeader As BITMAPINFOHEADER
    bmiColors(255) As Long

End Type

Private Type RECT

    Left As Long
    Top As Long
    Right As Long
    Bottom As Long

End Type

Private Declare Function StretchDIBits _
                Lib "gdi32.dll" (ByVal hdc As Long, _
                                 ByVal x As Long, _
                                 ByVal y As Long, _
                                 ByVal dx As Long, _
                                 ByVal dy As Long, _
                                 ByVal SrcX As Long, _
                                 ByVal SrcY As Long, _
                                 ByVal wSrcWidth As Long, _
                                 ByVal wSrcHeight As Long, _
                                 ByRef lpBits As Any, _
                                 ByRef lpBitsInfo As BITMAPINFO, _
                                 ByVal wUsage As Long, _
                                 ByVal dwRop As Long) As Long

Private Declare Function CreateSolidBrush Lib "gdi32.dll" (ByVal crColor As Long) As Long

Private Declare Function FillRect _
                Lib "user32.dll" (ByVal hdc As Long, _
                                  ByRef lpRect As RECT, _
                                  ByVal hBrush As Long) As Long

Private Declare Function GetDC Lib "user32.dll" (ByVal hWnd As Long) As Long

Private Declare Function CreateCompatibleDC Lib "gdi32.dll" (ByVal hdc As Long) As Long

Private Declare Function CreateCompatibleBitmap _
                Lib "gdi32.dll" (ByVal hdc As Long, _
                                 ByVal nWidth As Long, _
                                 ByVal nHeight As Long) As Long

Private Declare Function SelectObject _
                Lib "gdi32.dll" (ByVal hdc As Long, _
                                 ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32.dll" (ByVal hObject As Long) As Long

Private Declare Function DeleteDC Lib "gdi32.dll" (ByVal hdc As Long) As Long

Private Declare Function ReleaseDC _
                Lib "user32.dll" (ByVal hWnd As Long, _
                                  ByVal hdc As Long) As Long

Private Declare Function OleCreatePictureIndirect _
                Lib "olepro32.dll" (lpPictDesc As PictDesc, _
                                    riid As Guid, _
                                    ByVal fPictureOwnsHandle As Long, _
                                    ipic As IUnknown) As Long

Public Function BitmapToPicture(ByVal hBmp As Long, _
                                ByVal fPictureOwnsHandle As Long) As StdPicture

    If (hBmp = 0) Then Exit Function
   
    Dim oNewPic As IUnknown, tPicConv As PictDesc, IGuid As Guid
   
    ' Fill PictDesc structure with necessary parts:
    With tPicConv
        .cbSizeofStruct = Len(tPicConv)
        .picType = vbPicTypeBitmap
        .hImage = hBmp
    End With
   
    ' Fill in IUnknown Interface ID
    With IGuid
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With
   
    ' Create a picture object:
    OleCreatePictureIndirect tPicConv, IGuid, fPictureOwnsHandle, oNewPic
   
    ' Return it:
    Set BitmapToPicture = oNewPic
   
End Function

'color depth: 8 bits, 0=white, all other=black
'width must be a multiple of 4
Public Function ByteArrayToPicture(ByVal lp As Long, _
                                   ByVal nWidth As Long, _
                                   ByVal nHeight As Long, _
                                   Optional ByVal nLeftPadding As Long, _
                                   Optional ByVal nTopPadding As Long, _
                                   Optional ByVal nRightPadding As Long, _
                                   Optional ByVal nBottomPadding As Long) As StdPicture

    Dim tBMI       As BITMAPINFO

    Dim h          As Long, hdc As Long, hBmp As Long

    Dim hbr        As Long

    Dim r          As RECT

    Dim nDestWidth As Long, nDestHeight As Long

    '    nDestWidth = IIf(nWidth < 64, 64, nWidth)
    '    nDestHeight = IIf(nHeight < 64, 64, nHeight)
    nDestWidth = 1024
    nDestHeight = 1024

    With tBMI.bmiHeader
        .biSize = 40&
        .biWidth = nWidth
        .biHeight = -nHeight
        .biPlanes = 1
        .biBitCount = 8
        .biSizeImage = nWidth * nHeight
        .biClrUsed = 256
    End With

    tBMI.bmiColors(0) = &HFFFFFF
    tBMI.bmiColors(2) = &H808080 'debug only
    '///
    h = GetDC(0)
    hdc = CreateCompatibleDC(h)
    r.Right = nDestWidth + nLeftPadding + nRightPadding - 104
    r.Bottom = nDestHeight + nTopPadding + nBottomPadding - 104
    hBmp = CreateCompatibleBitmap(h, r.Right, r.Bottom)
    hBmp = SelectObject(hdc, hBmp)
    '///
    hbr = CreateSolidBrush(vbWhite)
    FillRect hdc, r, hbr
    DeleteObject hbr
    StretchDIBits hdc, nLeftPadding, nTopPadding, nDestWidth, nDestHeight, 0, 0, nWidth, nHeight, ByVal lp, tBMI, 0, vbSrcCopy
    '///
    hBmp = SelectObject(hdc, hBmp)
    DeleteDC hdc
    ReleaseDC 0, h
    '///
    Set ByteArrayToPicture = BitmapToPicture(hBmp, 1)
End Function
